#include <stdio.h>

int main() {
	int w, h;
	char c;
	
	while (scanf("%d %d", &h, &w) > 0) {
		if (w == 0 && h == 0) break;
		getchar();
		getchar();
		c = getchar();
		getchar();
		getchar();
				
		char frame1[1000][1000];
		char frame2[1000][1000];

		int startX1 = -1, startY1 = -1;
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++) {
				frame1[x][y] = getchar();
				if (startX1 == -1 && frame1[x][y] == c) {
					startX1 = x;
					startY1 = y;
				}
			}
			
			getchar();
		}
		
		getchar();
		
		int startX2 = -1, startY2 = -1;
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++) {
				frame2[x][y] = getchar();
				if (startX2 == -1 && frame2[x][y] == c) {
					startX2 = x;
					startY2 = y;
				}
			}
			
			getchar();
		}
		
		getchar();
		
		int deltaX = startX2 - startX1;
		int deltaY = startY2 - startY1;
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++) {
				int nX = x - deltaX, nY = y - deltaY;
				if (nX >= 0 && nX < w && nY >= 0 && nY < h && frame2[nX][nY] == c) {
					putchar(c);
				}
				else if (frame1[x][y] == c) putchar(frame2[x][y]);
				else putchar(frame1[x][y]); 
			}
			
			putchar('\n');
		}
		
		putchar('\n');
	}
	
	return 0;
}

